##Calculate ozone exposure metric from model output
##Model output can be requested from the Centre for Environmental Data Analysis 
##website: http://data.ceda.ac.uk/badc/wcrp-ccmi/data/CCMI-1/output/
##Last assess: 28 Feb 2019
##Illustation was made for CHASER output in 2008
##this script needs to be manually changed/adopted for different year or model
##6-month running mean was ran through from January 2008 to March 2009
##(summer at southern hemisphere ends about March)
##Citation: Chang, K.-L., Cooper, O.R., West, J.J., Serre, M.L., Schultz, M.G.,
##Lin, M., Marécal, V., Josse, B., Deushi, M., Sudo, K., Liu, J., and Keller, C.A.:
##A new method (M3Fusion v1) for combining observations and multiple model output
##for an improved estimate of the global surface ozone distribution,
##Geosci. Model Dev., 2019.


col=c(rgb(0.2081, 0.1663, 0.5292),
rgb(0.3961, 0.3176, 0.8000),
rgb(0.0123, 0.4213, 0.8802),
rgb(0.4941, 0.7647, 0.8980),
rgb(0.1157, 0.7022, 0.6843),
rgb(0.5216, 0.6980, 0.1725),
rgb(0.9968, 0.7513, 0.2325),
rgb(1.0000, 0.4863, 0.0000),
rgb(0.8000, 0.3176, 0.3176),
rgb(0.6980, 0.1725, 0.1725))
N=10

####################################################################################################
library(chron)
library(RColorBrewer)
library(lattice)
library(ncdf4)
library(mgcv)
library(data.table)
library(fields)

ncname <- "sfvmro3_hourly_CHASER-MIROC-ESM_refC2_r1i1p1_200801010030-200812302330"
ncfname <- paste(ncname, ".nc", sep = "")
ncin <- nc_open(ncfname)
print(ncin)
#res 2.8*2.8
lon = ncvar_get(ncin, "lon")
lat = ncvar_get(ncin, "lat")
time= ncvar_get(ncin, "time", verbose = F)

ots.array = ncvar_get(ncin, "sfvmro3")
dim(ots.array)

ots=ots.array
ndays=length(ots[1,1,])/24
ni=length(lon)
nj=length(lat)

world8hr=array(0,dim=c(ni,nj,ndays))
worldhr=array(0,dim=c(ni,nj,ndays))
endday=24



for (i in 1:ni){
 xloctm = lon[i]/15

  if (xloctm <=12){
    offset=-floor(xloctm)
	for (j in 1:nj){
	for (day in 1:(ndays-1)){
		mn=offset+24*(day-1)
		max=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
		maxhr=0
			for (hr in 1:16){
			m=mn+hr
			max1=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			if (max1>max)
			max=max1
			maxhr=hr
		world8hr[i,j,day]=max*10^9
		worldhr[i,j,day]=maxhr+1
		}}}}
	else{
    offset=24-floor(xloctm)
	for (j in 1:nj){ 
	for (day in 1:(ndays-1)){
		mn=offset+24*(day-1)
		max=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			maxhr=0
			for (hr in 1:16){
			m=mn+hr
			max1=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			if (max1>max)
			max=max1
			maxhr=hr
		world8hr[i,j,day]=max*10^9
		worldhr[i,j,day]=maxhr+1
		}}}}
}

su8hr01=apply(world8hr[,,1:31],c(1,2),mean)
su8hr02=apply(world8hr[,,32:59],c(1,2),mean)
su8hr03=apply(world8hr[,,60:90],c(1,2),mean)
su8hr04=apply(world8hr[,,91:120],c(1,2),mean)
su8hr05=apply(world8hr[,,121:151],c(1,2),mean)
su8hr06=apply(world8hr[,,152:181],c(1,2),mean)
su8hr07=apply(world8hr[,,182:212],c(1,2),mean)
su8hr08=apply(world8hr[,,213:243],c(1,2),mean)
su8hr09=apply(world8hr[,,244:273],c(1,2),mean)
su8hr10=apply(world8hr[,,274:304],c(1,2),mean)
su8hr11=apply(world8hr[,,305:335],c(1,2),mean)
su8hr12=apply(world8hr[,,335:365],c(1,2),mean)


###################################################################################
###################################################################################

ncname <- "sfvmro3_hourly_CHASER-MIROC-ESM_refC2_r1i1p1_200901010030-200912312330"
ncfname <- paste(ncname, ".nc", sep = "")
ncin <- nc_open(ncfname)

lon = ncvar_get(ncin, "lon")
lat = ncvar_get(ncin, "lat")

ots.array = ncvar_get(ncin, "sfvmro3")
dim(ots.array)

ots=ots.array
ndays=length(ots[1,1,])/24
ni=length(lon)
nj=length(lat)

world8hr=array(0,dim=c(ni,nj,ndays))
worldhr=array(0,dim=c(ni,nj,ndays))
endday=24



for (i in 1:ni){
 xloctm = lon[i]/15

  if (xloctm <=12){
    offset=-floor(xloctm)
	for (j in 1:nj){
	for (day in 1:(ndays-1)){
		mn=offset+24*(day-1)
		max=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
		maxhr=0
			for (hr in 1:16){
			m=mn+hr
			max1=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			if (max1>max)
			max=max1
			maxhr=hr
		world8hr[i,j,day]=max*10^9
		worldhr[i,j,day]=maxhr+1
		}}}}
	else{
    offset=24-floor(xloctm)
	for (j in 1:nj){ 
	for (day in 1:(ndays-1)){
		mn=offset+24*(day-1)
		max=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			maxhr=0
			for (hr in 1:16){
			m=mn+hr
			max1=mean(c(ots[i,j,mn],ots[i,j,(mn+1)],ots[i,j,(mn+2)],ots[i,j,(mn+3)],ots[i,j,(mn+4)],ots[i,j,(mn+5)],ots[i,j,(mn+6)],ots[i,j,(mn+7)]), na.rm=T)
			if (max1>max)
			max=max1
			maxhr=hr
		world8hr[i,j,day]=max*10^9
		worldhr[i,j,day]=maxhr+1
		}}}}
}

su8hr13=apply(world8hr[,,1:31],c(1,2),mean)
su8hr14=apply(world8hr[,,32:59],c(1,2),mean)
su8hr15=apply(world8hr[,,60:90],c(1,2),mean)

rdma8=matrix(0,ncol=nj, nrow=ni)

for (i in 1:ni){
	for (j in 1:nj){
rdma8[i,j]=max(rowMeans(embed(c(su8hr01[i,j],su8hr02[i,j],su8hr03[i,j],su8hr04[i,j],su8hr05[i,j],su8hr06[i,j],su8hr07[i,j],su8hr08[i,j],su8hr09[i,j],su8hr10[i,j],su8hr11[i,j],su8hr12[i,j],su8hr13[i,j],su8hr14[i,j],su8hr15[i,j]),6), na.rm=T))
}}

rdma8=rbind(rdma8[65:128,], rdma8[1:64,])


#bilinear interpolation onto 0.125 resolution
obj=list(x=ncvar_get(ncin, "lon")-180, y=ncvar_get(ncin, "lat"), z=rdma8)
make.surface.grid(list(seq(-180, by=0.125,length=2880), seq(-90, by=0.125,length=1441)))-> loc
interp.surface(obj, loc)-> su8hr
#image.plot(as.surface(loc, su8hr))

su8hr=matrix(su8hr, nrow=2880)
write.table(su8hr,"CCMI-CHASER-warm-dma8-2008.txt", sep=" ", row.names=F, col.names=F)

png("DMA8_CHASER_2008.png", height =10, width =14, units ="in", res =300)
par(mar=c(3.5, 3.5, 2, 1), mgp=c(2.4, 0.8, 0), las=1)
image.plot(seq(-180, by=0.125,length=2880), seq(-90, by=0.125,length=1441), su8hr, xlab="longitude",ylab="latitude", horizontal=F, col=col, breaks=seq(0, 100, length.out= N+1))
map(add=T)
mtext('(ppb)', side=3, line=0, at=200, cex=1.5)
dev.off()


